const { Area, User } = require("../../models");
const { NO_FILE, SERVER_ERROR } = require("../../utils/errorMessage");
const { STATUS_CODE } = require("../../utils/utility");
const routeHandler = require("../../utils/routeHandler");
const { isNull } = require("../../utils/validation");
const { sendAppError } = require("../../utils/appError");
const { Op, fn, col, literal } = require("sequelize");
const fastcsv = require('fast-csv');
const path = require('path');
const fs = require('fs');

const create = routeHandler(async (req, res, extras, next) => {
    const {
        area_name,
        area_descp
    } = req.body;

    const { user_id, branch_id } = req.auth;

    const paramNames = ["Area Name"];
    const { hasNull, missingParams } = isNull([area_name]);
    if (hasNull) {
        const missingParamNames = missingParams.map(index => paramNames[index]);
        return sendAppError(extras, `${missingParamNames.join(', ')} ${missingParamNames.length > 1 ? 'are' : 'is'} required`, STATUS_CODE.BAD_REQUEST);
    }
    try {
        const findArea = await Area.findOne({
            where: {
                [Op.or]: [
                    { area_name }
                ],
            },
        });

        if (findArea) {
            if (findArea.area_name === area_name) {
                return sendAppError(extras, "Area Name already exists", STATUS_CODE.BAD_REQUEST);
            }
        }

        const area = await Area.create({
            branch_id,
            area_name,
            area_descp,
            created_by: user_id
        }, { transaction: extras.transaction });

        await extras.transaction.commit();
        const areaDetails = await getDetails(area.area_id);
        return res.sendRes(areaDetails, { message: 'Area created successfully', status: STATUS_CODE.OK });
    } catch (error) {
        await extras.transaction.rollback();
        return sendAppError(extras, error.message, STATUS_CODE.INTERNAL_SERVER_ERROR);
    }
});

const getAll = routeHandler(async (req, res, extras) => {
    const { search, active_status, order_by } = req.query;
    const { branch_id } = req.auth;
    let findObj = findObject(search, branch_id, active_status);
    try {
        const areas = await Area.findAll({
            where: findObj,
            include: [
                {
                    model: User,
                    as: 'user_created',
                    attributes: ['user_id', 'fullname'],
                },
                {
                    model: User,
                    as: 'user_updated',
                    attributes: ['user_id', 'fullname'],
                },
            ],
            order: [['created_at', order_by == 1 ? 'ASC' : 'DESC']],
            ...req.paginate,
        });

        return res.sendRes(areas, {
            message: 'Area loaded successfully',
            ...req.meta,
            total: await Area.count({ where: findObj }),
            status: STATUS_CODE.OK,
        });

    } catch (error) {
        await extras.transaction.rollback();
        return sendAppError(extras, error.message, STATUS_CODE.INTERNAL_SERVER_ERROR);
    }
}, false);

function findObject(search, branch_id, active_status) {
    let findObj = {};

    if (search) {
        findObj[Op.or] = [
            { area_name: { [Op.substring]: search } },
            { area_descp: { [Op.substring]: search } }
        ];
    }

    if (branch_id && branch_id != 'undefined') findObj.branch_id = branch_id;
    if (active_status && active_status != 'undefined') findObj.active_status = active_status;

    return findObj;
}

const getById = routeHandler(async (req, res, extras) => {
    const { area_id } = req.params;

    try {
        const area = await Area.findOne({
            where: { area_id }
        });

        if (!area) {
            return sendAppError(extras, 'Area not found', STATUS_CODE.NOT_FOUND);
        }

        return res.sendRes(area, { message: 'Area loaded successfully', status: STATUS_CODE.OK });
    } catch (error) {
        await extras.transaction.rollback();
        return sendAppError(extras, error.message, STATUS_CODE.INTERNAL_SERVER_ERROR);
    }
}, false);

const updateById = routeHandler(async (req, res, extras) => {
    const { area_id } = req.params;
    const { user_id } = req.auth;
    const { area_name, area_descp, changeStatus } = req.body;

    try {
        const area = await Area.findOne({
            where: { area_id },
        });

        if (!area) {
            return sendAppError(extras, 'Area not found', STATUS_CODE.NOT_FOUND);
        }

        if (changeStatus) {
            const newStatus = area.active_status === true ? false : true;
            await area.update({
                active_status: newStatus,
                updated_by: user_id,
            }, { transaction: extras.transaction });

            await extras.transaction.commit();
            const areaDetails = await getDetails(area.area_id);
            return res.sendRes(areaDetails, { message: 'Area status updated successfully', status: STATUS_CODE.OK });
        }

        if (area_name) {
            const findArea = await Area.findOne({
                where: {
                    area_name,
                    branch_id,
                    area_id: { [Op.ne]: area_id },
                },
                paranoid: false,
            });

            if (findArea) {
                return sendAppError(extras, "Area Name already exists", STATUS_CODE.BAD_REQUEST);
            }
        }

        await area.update({
            area_name,
            area_descp,
            updated_by: user_id,
        }, { transaction: extras.transaction });

        await extras.transaction.commit();
        const areaDetails = await getDetails(area.area_id);
        return res.sendRes(areaDetails, { message: 'Area details updated successfully', status: STATUS_CODE.OK });

    } catch (error) {
        await extras.transaction.rollback();
        return sendAppError(extras, error.message, STATUS_CODE.INTERNAL_SERVER_ERROR);
    }
});

const deleteById = routeHandler(async (req, res, extras) => {
    const { area_id } = req.params;

    try {
        const area = await Area.findOne({ where: { area_id } });
        if (!area) {
            return sendAppError(extras, 'Area not found', STATUS_CODE.NOT_FOUND);
        }

        await area.update({
            deleted_by: req.auth.user_id,
        }, { transaction: extras.transaction });

        await area.destroy({ transaction: extras.transaction });
        await extras.transaction.commit();
        return res.sendRes(null, { message: 'Area details deleted successfully', status: STATUS_CODE.OK });
    } catch (error) {
        await extras.transaction.rollback();
        return sendAppError(extras, error.message, STATUS_CODE.INTERNAL_SERVER_ERROR);
    }
});

const bulkUpload = routeHandler(async (req, res, extras) => {
    const file = req.file;
    const { user_id, branch_id } = req.auth;

    if (!file) {
        return sendAppError(extras, NO_FILE, STATUS_CODE.BAD_REQUEST);
    }

    const filePath = path.join(__dirname, '../../uploads', file.filename || `${Date.now()}_${file.originalname}`);
    if (file.buffer) {
        fs.writeFileSync(filePath, file.buffer);
    }
    const areasData = [];
    const errors = [];
    const stream = fs.createReadStream(filePath);
    try {
        const processingPromises = [];

        await new Promise((resolve, reject) => {
            fastcsv.parseStream(stream, { headers: true })
                .on('data', (row) => {
                    processingPromises.push(
                        (async () => {
                            const { rowRefId, rowAreaName, rowAreaDesc } = row;
                            if (!rowAreaName) {
                                errors.push('Area Name is required');
                            } else {
                                try {
                                    const existingArea = await Area.findOne({ where: { area_name: rowAreaName } });

                                    if (!existingArea) {
                                        areasData.push({
                                            tbl_ref_id: rowRefId,
                                            branch_id: branch_id,
                                            area_name: rowAreaName,
                                            area_descp: rowAreaDesc,
                                            created_by: user_id
                                        });
                                    }
                                } catch (dbError) {
                                    reject(dbError);
                                }
                            }
                        })()
                    );
                })
                .on('end', async () => {
                    try {
                        await Promise.all(processingPromises);
                        resolve();
                    } catch (err) {
                        reject(err);
                    }
                })
                .on('error', (error) => reject(error));
        });
        if (errors.length > 0) {
            return sendAppError(extras, errors.join(', '), STATUS_CODE.BAD_REQUEST);
        }

        await extras.transaction.begin();
        try {
            const areas = await Area.bulkCreate(areasData, { transaction: extras.transaction });
            await extras.transaction.commit();
            return res.sendRes(areas, { message: 'Areas created successfully', status: STATUS_CODE.OK });
        } catch (error) {
            await extras.transaction.rollback();
            return sendAppError(extras, 'Failed to create areas', STATUS_CODE.INTERNAL_SERVER_ERROR);
        }
    } catch (error) {
        return sendAppError(extras, 'Error processing file', STATUS_CODE.INTERNAL_SERVER_ERROR);
    } finally {
        fs.unlinkSync(filePath);
    }
});

async function getDetails(id) {
    return await Area.findOne({
        where: { area_id: id },
        include: [
            {
                model: User,
                as: 'user_created',
                attributes: ['user_id', 'fullname'],
            },
            {
                model: User,
                as: 'user_updated',
                attributes: ['user_id', 'fullname'],
            },
        ],
    });
}

module.exports = {
    create,
    getAll,
    getById,
    updateById,
    deleteById,
    bulkUpload
};
